local addonName, addon = ...

addon.defaultSettings = {
	alpha		= 0.75,
	anchor		= 'CENTER',
	blue		= 0.125,
	clamp		= 0,
	degrees		= 135,
	flipFlop	= false,
	frequency	= 15,
	green		= 1,
	height		= 14.4,
	level		= 32,
	lock		= false,
	offsetX		= 0,
	offsetY		= 0,
	parameters	= "",
	red			= 0.125,
	scale		= 1,
	strata		= 4,
	width		= 115.2
}

--[[----------------------------------------------------------------------------
Config mode support
------------------------------------------------------------------------------]]
if type(CONFIGMODE_CALLBACKS) ~= 'table' then
	CONFIGMODE_CALLBACKS = { }
end

function addon.ConfigMode(action)
	if action == 'ON' then
		addon.db.profile.lock = false
	elseif action == 'OFF' then
		addon.db.profile.lock = true
	else
		return
	end
	addon:ApplySettings()
	if addon.config then
		addon.config:Refresh()
	end
end

--[[----------------------------------------------------------------------------
Load on demand configuration
------------------------------------------------------------------------------]]
local LOA = LibStub('LibOptionsAssist-1.1', true)
if not (LOA and select(2, GetAddOnInfo(addonName .. '_Config'))) then return end	-- Make sure config support exists

addon.config = LOA.AddEntry(addonName, nil, function()
	addon.L = setmetatable({ }, { __index = function(self, key)
		self[key] = key
		return key
	end })

	return addonName .. "_Config", addonName, addon, addon.L
end)

--[[----------------------------------------------------------------------------
Slash command
------------------------------------------------------------------------------]]
_G['SLASH_' .. addonName .. 1] = '/' .. addonName:lower()
SlashCmdList[addonName] = addon.config
